//
//  BigLetterView.m
//  TypingTutor
//
//  Created by narita on 2013/12/25.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import "BigLetterView.h"

@implementation BigLetterView

- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    
    if (self)
    {
        NSLog(@"initalize view");
        
        self.bgColor = [NSColor yellowColor];
        self.string = @"";
        
    }
    return self;
}

// アクセッサ
@synthesize bgColor = _bgColor;

- (void) setBgColor:(NSColor *)bgColor
{
    _bgColor = bgColor;
    [self setNeedsDisplay:YES];
}

- (NSColor*) bgColor
{
    return _bgColor;
}

@synthesize string = _string;

- (void) setString:(NSString *)string
{
    _string = string;
    
    NSLog(@"setString:%@", string);

}

- (NSString*) string
{
    return _string;
}

// マウス
- (void) viewDidMoveToWindow
{
    // マウスカーソルがこのviewの領域に出入りした瞬間にmouseEntered or mouseExitedを呼出す。
    NSTrackingArea* theTrackingArea;
    NSInteger       theOption;
    
    theOption = NSTrackingMouseEnteredAndExited | NSTrackingActiveAlways | NSTrackingInVisibleRect;
    
    theTrackingArea = [[NSTrackingArea alloc] initWithRect:NSZeroRect
                                                   options:theOption
                                                     owner:self
                                                  userInfo:nil];
    
    [self addTrackingArea:theTrackingArea];
}

- (void) mouseEntered:(NSEvent *)theEvent
{
    self.highlighted = YES;
    [self setNeedsDisplay:YES];
}

- (void) mouseExited:(NSEvent *)theEvent
{
    self.highlighted = NO;
    [self setNeedsDisplay:YES];
}

- (void) resetCursorRects
{
    [self addCursorRect:[self bounds]
                 cursor:[NSCursor IBeamCursor]];
}

// 描画系
- (void)drawRect:(NSRect)dirtyRect
{
    NSRect theBounds = [self bounds];
    
    if( self.isHighlighted )
    {
        [[NSColor highlightColor] set];
    }
    else
    {
        [self.bgColor set];
    }
    
    [NSBezierPath fillRect:theBounds];
    
    if(
       [[self window] firstResponder] == self
       &&
       [NSGraphicsContext currentContextDrawingToScreen]
       )
    {
        [NSGraphicsContext saveGraphicsState];
        
        NSSetFocusRingStyle(NSFocusRingOnly);
        [NSBezierPath fillRect:theBounds];
        
        [NSGraphicsContext restoreGraphicsState];
    }
}

- (BOOL) isOpaque
{
    return YES;
}

// firstResponder系
- (BOOL) acceptsFirstResponder
{
    NSLog(@"accepting");
    return YES;
}

- (BOOL) resignFirstResponder
{
    NSLog(@"resigning");
    
    [self setKeyboardFocusRingNeedsDisplayInRect:[self bounds]];
    
    return YES;
}

- (BOOL) becomeFirstResponder
{
    NSLog(@"becoming");
    
    [self setNeedsDisplay:YES];
    
    return YES;
}

// キー入力系

- (void) keyDown:(NSEvent *)theEvent
{
    [self interpretKeyEvents:[NSArray arrayWithObject:theEvent]];
}

- (void) insertText:(id)insertString
{
    self.string = insertString;
}

- (void) insertTab:(id)sender
{
    [[self window] selectKeyViewFollowingView:self];
}

- (void) insertBacktab:(id)sender
{
    [[self window] selectKeyViewPrecedingView:self];
}

- (void) deleteBackward:(id)sender
{
    self.string = @"";
}

@end
